﻿/*******************************************************************************
 * Copyright 2019 Viridian Software Limited
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
using Java.Lang;
using Org.Mini2Dx.Lockprovider;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace monogame.Locks
{
    public class MonoGameReadWriteLock : global::Java.Lang.Object, ReadWriteLock
    {
        ReaderWriterLockSlim @lock = new ReaderWriterLockSlim(LockRecursionPolicy.SupportsRecursion);

        public void lockRead_EFE09FC0()
        {
            bool locked = false;
            while(!locked)
            {
                try
                {
                    @lock.EnterReadLock();
                    locked = true;
                }
                catch (System.Exception e)
                {
                    //Java retries until locked
                    continue;
                }
            }
        }

        public void lockWrite_EFE09FC0()
        {
            bool locked = false;
            while(!locked)
            {
                try
                {
                    @lock.EnterWriteLock();
                    locked = true;
                }
                catch (System.Exception e)
                {
                    //Java retries until locked
                    continue;
                }
            }

        }

        public bool tryLockRead_FBE0B2A4()
        {
            try
            {
                return @lock.TryEnterReadLock(0);
            }
            catch (System.Exception)
            {
                return false;
            }
        }

        public bool tryLockWrite_FBE0B2A4()
        {
            try
            {
                return @lock.TryEnterWriteLock(0);
            }
            catch (System.Exception)
            {
                return false;
            }
        }

        public void unlockRead_EFE09FC0()
        {
            @lock.ExitReadLock();
        }

        public void unlockWrite_EFE09FC0()
        {
            @lock.ExitWriteLock();
        }
    }
}
